SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

-- --------------------------------------------------------

--
-- Table structure for table `gk_app_items`
--

DROP TABLE IF EXISTS `gk_app_items`;
CREATE TABLE IF NOT EXISTS `gk_app_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'untitled',
  `description` varchar(255) COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `status` int(11) NOT NULL DEFAULT '0',
  `sort_order` int(11) NOT NULL DEFAULT '0',
  `date_modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `gk_block_categories`
--

DROP TABLE IF EXISTS `gk_block_categories`;
CREATE TABLE IF NOT EXISTS `gk_block_categories` (
  `cid` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'untitled',
  `sort_order` int(11) NOT NULL DEFAULT '0',
  `status` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`cid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `gk_block_config`
--

DROP TABLE IF EXISTS `gk_block_config`;
CREATE TABLE IF NOT EXISTS `gk_block_config` (
  `section` varchar(32) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'untitled',
  `key` varchar(64) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'untitled',
  `value` text COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `date_updated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `user_id` bigint(16) NOT NULL DEFAULT '0',
  UNIQUE KEY `primary_key` (`section`,`key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `gk_block_items`
--

DROP TABLE IF EXISTS `gk_block_items`;
CREATE TABLE `gk_block_items` (
	`id` INT(11) NOT NULL AUTO_INCREMENT,
	`category_id` INT(11) NOT NULL DEFAULT '0',
	`title` varchar(255) NOT NULL DEFAULT 'untitled' COLLATE 'utf8_unicode_ci',
	`original_block` varchar(64) NOT NULL DEFAULT '' COLLATE 'utf8_unicode_ci',
	`description` varchar(255) NOT NULL DEFAULT '' COLLATE 'utf8_unicode_ci',
	`status` INT(11) NOT NULL DEFAULT '0',
	`sort_order` INT(11) NOT NULL DEFAULT '0',
	`date_modified` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
	`display_in_menu` TINYINT(1) NOT NULL DEFAULT '1',
	`permission_read` VARCHAR(2047) NOT NULL DEFAULT 's:8:"everyone";',
	`permission_write` VARCHAR(2047) NOT NULL DEFAULT 'a:1:{i:0;s:1:"1";}',
	
	PRIMARY KEY (`id`),
	INDEX `category_id` (`category_id`),
	INDEX `title` (`title`),
	INDEX `original_block` (`original_block`),
	INDEX `status` (`status`),
	INDEX `sort_order` (`sort_order`)
)
COLLATE='utf8_unicode_ci'
ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `gk_block_menu_association`
--

DROP TABLE IF EXISTS `gk_block_menu_association`;
CREATE TABLE IF NOT EXISTS `gk_block_menu_association` (
  `id` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `menu_id` int(11) UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`,`menu_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `gk_blog_categories`
--

DROP TABLE IF EXISTS `gk_blog_categories`;
CREATE TABLE `gk_blog_categories` (
	`cid` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
	`parent_id` INT(20) UNSIGNED NULL DEFAULT '0',
	`title` varchar(255) NOT NULL DEFAULT 'untitled' COLLATE 'utf8_unicode_ci',
	`virtual_filename` varchar(255) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`date_created` DATETIME NULL DEFAULT NULL,
	`date_modified` DATETIME NULL DEFAULT NULL,
	`date_available` DATETIME NULL DEFAULT NULL,
	`date_expiry` DATETIME NULL DEFAULT NULL,
	`created_by_id` BIGINT(20) NOT NULL DEFAULT '0',
	`modified_by_id` BIGINT(20) DEFAULT NULL,
	`summary` TEXT NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`description` TEXT NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`sort_order` INT(3) NULL DEFAULT NULL,
	`status` TINYINT(1) NOT NULL DEFAULT '1',
	`pageview` BIGINT(20) NOT NULL DEFAULT '0',
	`items_per_page` INT(11) NOT NULL DEFAULT '10',
	`permission_write` varchar(2047) NOT NULL DEFAULT 'a:1:{i:0;s:1:"1";}' COLLATE 'utf8_unicode_ci',
	`permission_read` varchar(2047) NOT NULL DEFAULT 's:8:"everyone";' COLLATE 'utf8_unicode_ci',
	`options` varchar(2047) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`meta_key` varchar(1023) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`meta_description` varchar(255) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	PRIMARY KEY (`cid`),
	INDEX `parent_id` (`parent_id`),
	INDEX `title` (`title`),
	INDEX `virtual_filename` (`virtual_filename`),
	INDEX `date_created` (`date_created`),
	INDEX `date_modified` (`date_modified`),
	INDEX `date_available` (`date_available`),
	INDEX `date_expiry` (`date_expiry`),
	INDEX `created_by_id` (`created_by_id`),
	INDEX `modified_by_id` (`modified_by_id`),
	INDEX `sort_order` (`sort_order`),
	INDEX `status` (`status`)
)
COLLATE='utf8_unicode_ci'
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `gk_blog_items`
--

DROP TABLE IF EXISTS `gk_blog_items`;
CREATE TABLE `gk_blog_items` (
	`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
	`category_id` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
	`title` varchar(255) NOT NULL DEFAULT 'untitled' COLLATE 'utf8_unicode_ci',
	`virtual_filename` varchar(255) NOT NULL DEFAULT 'untitled' COLLATE 'utf8_unicode_ci',
	`summary` TEXT NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`description` TEXT NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`date_created` DATETIME NULL DEFAULT NULL,
	`date_modified` DATETIME NULL DEFAULT NULL,
	`date_available` DATETIME NULL DEFAULT NULL,
	`date_expiry` DATETIME NULL DEFAULT NULL,
	`created_by_id` BIGINT(20) NOT NULL DEFAULT '0',
	`modified_by_id` BIGINT(20) DEFAULT NULL,
	`permission_write` varchar(2047) NOT NULL DEFAULT 'a:1:{i:0;s:1:"1";}' COLLATE 'utf8_unicode_ci',
	`permission_read` varchar(2047) NOT NULL DEFAULT 's:8:"everyone";' COLLATE 'utf8_unicode_ci',
	`meta_key` varchar(1023) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`meta_description` varchar(255) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`status` INT(11) NOT NULL DEFAULT '1',
	`featured` TINYINT(1) NOT NULL DEFAULT '0',
	`close_pingback` TINYINT(1) NOT NULL DEFAULT '0',
	`close_commenting` TINYINT(1) NOT NULL DEFAULT '0',
	`hide_comments` TINYINT(1) NOT NULL DEFAULT '0',
	`pageview` BIGINT(20) NOT NULL DEFAULT '0',
	`sort_order` INT(11) NOT NULL DEFAULT '0',
	`options` varchar(2047) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	PRIMARY KEY (`id`),
	INDEX `category_id` (`category_id`),
	INDEX `virtual_filename` (`virtual_filename`),
	INDEX `title` (`title`),
	INDEX `date_created` (`date_created`),
	INDEX `date_modified` (`date_modified`),
	INDEX `status` (`status`),
	INDEX `created_by_id` (`created_by_id`),
	INDEX `modified_by_id` (`modified_by_id`),
	INDEX `sort_order` (`sort_order`)
)
COLLATE='utf8_unicode_ci'
ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `gk_config`
--

DROP TABLE IF EXISTS `gk_config`;
CREATE TABLE IF NOT EXISTS `gk_config` (
  `section` varchar(32) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'untitled',
  `key` varchar(64) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'untitled',
  `value` text COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `date_updated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `user_id` bigint(16) NOT NULL DEFAULT '0',
  UNIQUE KEY `primary_key` (`section`,`key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `gk_contact_categories`
--

DROP TABLE IF EXISTS `gk_contact_categories`;
CREATE TABLE IF NOT EXISTS `gk_contact_categories` (
  `cid` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `status` tinyint(1) NOT NULL DEFAULT '1',
  `parent_id` int(20) unsigned NOT NULL DEFAULT '0',
  `title` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'Untitled',
  `summary` text COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `virtual_filename` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `sort_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`cid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `gk_contact_items`
--

DROP TABLE IF EXISTS `gk_contact_items`;
CREATE TABLE IF NOT EXISTS `gk_contact_items` (
 `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `category_id` bigint(20) UNSIGNED NOT NULL DEFAULT '0',
  `title` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'untitled',
  `branch` varchar(255) COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `contact_person` varchar(255) COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `virtual_filename` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'untitled',
  `street` varchar(255) COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `city` varchar(255) COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `province` varchar(64) COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `postal` varchar(32) COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `country` varchar(64) COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `tollfree` varchar(255) COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `phone` varchar(255) COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `fax` varchar(255) COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `email` varchar(255) COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `mobile` varchar(255) COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `display_email` tinyint(1) NOT NULL DEFAULT '0',
  `additional_info` text COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `additional_options` text COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `status` int(11) NOT NULL DEFAULT '0',
  `sort_order` int(11) NOT NULL DEFAULT '0',
  `permission_write` varchar(2047) NOT NULL DEFAULT 'a:1:{i:0;s:1:"1";}' COLLATE 'utf8_unicode_ci',
  `permission_read` varchar(2047) NOT NULL DEFAULT 's:8:"everyone";' COLLATE 'utf8_unicode_ci',
  
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `gk_error_items`
--

DROP TABLE IF EXISTS `gk_error_items`;
CREATE TABLE IF NOT EXISTS `gk_error_items` ( 
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `datetime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `ipaddress` varchar(32) COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `useragent` varchar(255) COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `referrer` varchar(255) COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `request_uri` varchar(1024) COLLATE utf8_unicode_ci NULL DEFAULT NULL,  
  `description` text COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `gk_filter_config`
--

DROP TABLE IF EXISTS `gk_filter_config`;
CREATE TABLE IF NOT EXISTS `gk_filter_config` (
  `section` varchar(32) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'untitled',
  `key` varchar(64) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'untitled',
  `value` text COLLATE utf8_unicode_ci NULL DEFAULT NULL,
  `date_updated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `user_id` bigint(16) NOT NULL DEFAULT '0',
  UNIQUE KEY `primary_key` (`section`,`key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;


--
-- Table structure for table `gk_filter_items`
--

DROP TABLE IF EXISTS `gk_filter_items`;
CREATE TABLE IF NOT EXISTS `gk_filter_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'untitled',
  `description` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `status` int(11) NOT NULL DEFAULT '0',
  `sort_order` int(11) NOT NULL DEFAULT '0',
  `display_in_apps` tinyint(3) unsigned DEFAULT '1',
  `display_in_blocks` tinyint(3) unsigned DEFAULT '1',
  `date_modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `enabled_apps` text COLLATE utf8_unicode_ci,
  `enabled_blocks` text COLLATE utf8_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `status` (`status`),  
  KEY `sort_order` (`sort_order`)  
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `gk_html_categories`
--

DROP TABLE IF EXISTS `gk_html_categories`;
CREATE TABLE `gk_html_categories` (
	`cid` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
	`parent_id` INT(20) UNSIGNED NOT NULL DEFAULT '0',
	`title` varchar(255) NOT NULL DEFAULT 'untitled' COLLATE 'utf8_unicode_ci',
	`virtual_filename` varchar(255) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`date_created` DATETIME NULL DEFAULT NULL,
	`date_modified` DATETIME NULL DEFAULT NULL,
	`date_available` DATETIME NULL DEFAULT NULL,
	`date_expiry` DATETIME NULL DEFAULT NULL,
	`sort_order` INT(3) UNSIGNED NULL DEFAULT NULL,
	`status` TINYINT(1) NOT NULL DEFAULT '1',
	`featured` TINYINT(1) NOT NULL DEFAULT '0',
	`pageview` BIGINT(20) NOT NULL DEFAULT '0',
	`items_per_page` INT(11) UNSIGNED NOT NULL DEFAULT '10',
	`created_by_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
	`modified_by_id` BIGINT(20) UNSIGNED DEFAULT NULL,
	`meta_key` varchar(1023) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`meta_description` varchar(255) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',	
	`summary` TEXT NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`description` TEXT NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`permission_write` varchar(2047) NOT NULL DEFAULT 'a:1:{i:0;s:1:"1";}' COLLATE 'utf8_unicode_ci',
	`permission_read` varchar(2047) NOT NULL DEFAULT 's:8:"everyone";' COLLATE 'utf8_unicode_ci',
	`options` varchar(2047) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	PRIMARY KEY (`cid`),
	KEY `parent_id` (`parent_id`),
	KEY `date_created` (`date_created`),
	KEY `date_modified` (`date_modified`),
	KEY `sort_order` (`sort_order`),
	KEY `status` (`status`),
	KEY `created_by_id` (`created_by_id`),
	KEY `modified_by_id` (`modified_by_id`)
)
COLLATE='utf8_unicode_ci'
ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `gk_html_items`
--

DROP TABLE IF EXISTS `gk_html_items`;
CREATE TABLE `gk_html_items` (
	`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
	`category_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
	`title` varchar(255) NOT NULL DEFAULT 'untitled' COLLATE 'utf8_unicode_ci',
	`virtual_filename` varchar(255) NOT NULL DEFAULT 'untitled' COLLATE 'utf8_unicode_ci',
	`summary` TEXT NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`description` TEXT NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`date_created` DATETIME NULL DEFAULT NULL,
	`date_modified` DATETIME NULL DEFAULT NULL,
	`date_available` DATETIME NULL DEFAULT NULL,
	`date_expiry` DATETIME NULL DEFAULT NULL,
	`created_by_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
	`modified_by_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
	`permission_write` varchar(2047) NOT NULL DEFAULT 'a:1:{i:0;s:1:"1";}' COLLATE 'utf8_unicode_ci',
	`permission_read` varchar(2047) NOT NULL DEFAULT 's:8:"everyone";' COLLATE 'utf8_unicode_ci',
	`meta_key` varchar(1023) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`meta_description` varchar(255) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`pageview` BIGINT(20) NOT NULL DEFAULT '0',
	`status` INT(11) NOT NULL DEFAULT '0',
	`sort_order` INT(11) NOT NULL DEFAULT '0',
	`options` varchar(2047) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	PRIMARY KEY (`id`),
	KEY `category_id` (`category_id`),
	KEY `title` (`title`),
	KEY `id_category_id` (`id`,`category_id`),
	KEY `id_category_id_status` (`id`,`category_id`,`status`),	
	KEY `id_category_id_status_sort_order` (`id`,`category_id`,`status`,`sort_order`),
	KEY `virtual_filename` (`virtual_filename`),
	KEY `date_created` (`date_created`),
	KEY `date_modified` (`date_modified`),
	KEY `created_by_id` (`created_by_id`),
	KEY `modified_by_id` (`modified_by_id`),
	KEY `status` (`status`),
	KEY `sort_order` (`sort_order`)
)
COLLATE='utf8_unicode_ci'
ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `gk_menu_categories`
--

DROP TABLE IF EXISTS `gk_menu_categories`;
CREATE TABLE IF NOT EXISTS `gk_menu_categories` (
  `cid` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'untitled',
  `sort_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`cid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `gk_menu_items`
--

DROP TABLE IF EXISTS `gk_menu_items`;
CREATE TABLE `gk_menu_items` (
	`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
	`status` TINYINT(1) NOT NULL DEFAULT '1',
	`open_in_new_window` TINYINT(1) NOT NULL DEFAULT '1',
	`category_id` INT(11) NOT NULL DEFAULT '1',
	`parent_id` INT(20) NOT NULL DEFAULT '0',
	`title` varchar(255) NOT NULL DEFAULT 'untitled' COLLATE 'utf8_unicode_ci',
	`summary` TEXT NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`sort_order` INT(3) NULL DEFAULT NULL,
	`ssl_state` TINYINT(2) NOT NULL DEFAULT '0',
	`application` varchar(64) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`menuaction` varchar(64) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`menuitem` varchar(64) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`internalurl` varchar(255) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`sefurl` varchar(255) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`customurl` varchar(255) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`permission_read` VARCHAR(2047) NOT NULL DEFAULT 's:8:"everyone";',
	`permission_write` VARCHAR(2047) NOT NULL DEFAULT 'a:1:{i:0;s:1:"1";}',
	PRIMARY KEY (`id`),
	INDEX `category_id` (`category_id`),
	INDEX `status` (`status`),
	INDEX `parent_id` (`parent_id`),
	INDEX `sort_order` (`sort_order`)
)
COLLATE='utf8_unicode_ci'
ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------
--
-- Table structure for table `gk_template_items`
--

DROP TABLE IF EXISTS `gk_template_items`;
CREATE TABLE IF NOT EXISTS `gk_template_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'untitled',
  `description` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `status` int(11) NOT NULL DEFAULT '0',
  `sort_order` int(11) NOT NULL DEFAULT '0',
  `date_modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `gk_textbot_items`
--

DROP TABLE IF EXISTS `gk_textbot_items`;

-- --------------------------------------------------------

--
-- Table structure for table `gk_user_categories`
--

DROP TABLE IF EXISTS `gk_user_categories`;
CREATE TABLE IF NOT EXISTS `gk_user_categories` (
  `cid` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id`  bigint(20) unsigned DEFAULT '0',	
  `groupname` varchar(32) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'untitled',
  `status` int(11) NOT NULL DEFAULT '0',
  `items_per_page` int(11) NOT NULL DEFAULT '10',
  PRIMARY KEY (`cid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `gk_user_items`
--

DROP TABLE IF EXISTS `gk_user_items`;
CREATE TABLE `gk_user_items` (
	`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
	`username` varchar(32) NOT NULL DEFAULT '' COLLATE 'utf8_unicode_ci',
	`password` varchar(255) NOT NULL DEFAULT '' COLLATE 'utf8_unicode_ci',
	`firstname` varchar(64) NOT NULL DEFAULT '' COLLATE 'utf8_unicode_ci',
	`lastname` varchar(64) NOT NULL DEFAULT '' COLLATE 'utf8_unicode_ci',
	`email_address` varchar(255) NOT NULL DEFAULT '' COLLATE 'utf8_unicode_ci',
	`sort_order` INT(11) NOT NULL DEFAULT '0',
	`status` INT(11) NOT NULL DEFAULT '0',
	`date_created` DATETIME NULL DEFAULT NULL,
	`date_modified` DATETIME NULL DEFAULT NULL,
	`date_available` DATETIME NULL DEFAULT NULL,
	`date_expiry` DATETIME NULL DEFAULT NULL,
	`cookie` varchar(255) NOT NULL DEFAULT '' COLLATE 'utf8_unicode_ci',
	`session` varchar(255) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`ip` varchar(64) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`date_last_logged_in` TIMESTAMP NULL DEFAULT NULL,
	`date_last_failed_login_attempt` TIMESTAMP NULL DEFAULT NULL,
	`total_failed_login_attempt` INT(11) NULL DEFAULT NULL,
	`activation_string` varchar(255) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	`additional_info` MEDIUMTEXT NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
	PRIMARY KEY (`id`),
	UNIQUE INDEX `username` (`username`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;


--
-- Table structure for table `gk_user_categories_items`
--
DROP TABLE IF EXISTS `gk_user_categories_items`;
CREATE TABLE `gk_user_categories_items` (
	`id` BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
	`cid` BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
	PRIMARY KEY (`id`, `cid`)
)
COLLATE='utf8_unicode_ci'
ENGINE=MyISAM;